package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.Collections;
import java.util.List;

@CommandPermissions(permission = "clearinventory", source = SourceType.BOTH)
@CommandParameters(description = "Clear your inventory.", usage = "/<command> [player]", aliases = "ci,clear")
public class Command_clearinventory extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length < 1)
        {
            if (senderIsConsole)
            {
                return false;
            }

            playerSender.getInventory().clear();
            msgNew("<green>Your inventory has been cleared.");
        } else
        {
            if (plugin.al.isAdmin(sender))
            {
                if (args[0].equals("-a"))
                {
                    FUtil.adminAction(sender.getName(), "Clearing everyone's inventory", true);
                    server.getOnlinePlayers().forEach(player -> player.getInventory().clear());
                    msgNew("<green>Successfully cleared everyone's inventory.");
                } else
                {
                    Player player = getPlayer(args[0]);

                    if (player == null)
                    {
                        msg(PLAYER_NOT_FOUND);
                        return true;
                    }

                    player.getInventory().clear();
                    msgNew("<green>Successfully cleared <player>'s inventory.", Placeholder.unparsed("player", player.getName()));
                    msgNew(player, "<sender> has cleared your inventory.", Placeholder.unparsed("sender", sender.getName()));
                }
            } else
            {
                return noPerms();
            }
        }

        return true;
    }

    @Override
    public List<String> getTabCompleteOptions(CommandSender sender, Command command, String alias, String[] args)
    {
        if (args.length == 1 && plugin.al.isAdmin(sender))
        {
            List<String> players = FUtil.getPlayerList();
            players.add("-a");
            return players;
        }

        return Collections.emptyList();
    }
}