package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.rank.GroupProvider;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import net.luckperms.api.model.user.User;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(permission = "deop", source = SourceType.BOTH)
@CommandParameters(description = "Deop a player", usage = "/<command> <partialname>")
public class Command_deop extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length < 1)
        {
            return false;
        }

        boolean silent = false;
        if (args.length == 2)
        {
            silent = args[1].equalsIgnoreCase("-s");
        }

        Player player = Bukkit.getServer().getPlayer(args[0]);

        if (player == null || plugin.al.isVanished(player.getUniqueId()))
        {
            msg(sender, PLAYER_NOT_FOUND);
            return true;
        }

        User user = GroupProvider.getUser(player);
        if (user.getPrimaryGroup().equalsIgnoreCase(GroupProvider.NON_OP.getGroup().getLuckPermsGroup().getName()))
        {
            msgNew(sender, "<red><player> is already de-opped!", Placeholder.unparsed("<player>", player.getName()));
            return true;
        }
        user.setPrimaryGroup(GroupProvider.NON_OP.getGroup().getLuckPermsGroup().getName());
        msg(player, YOU_ARE_NOT_OP);
        plugin.rm.updateDisplay(player);

        if (!silent)
        {
            FUtil.adminAction(sender.getName(), "De-opping " + player.getName(), false);
        }

        return true;
    }
}