package me.totalfreedom.totalfreedommod.command;

import java.util.Iterator;
import me.totalfreedom.totalfreedommod.config.ConfigEntry;
import me.totalfreedom.totalfreedommod.fun.Landminer.Landmine;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(permission = "landmine", source = SourceType.ONLY_IN_GAME)
@CommandParameters(description = "Set a landmine trap.", usage = "/<command>")
public class Command_landmine extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (!ConfigEntry.LANDMINES_ENABLED.getBoolean())
        {
            msgNew("<red>Landmines are currently disabled.");
            return true;
        }

        if (!ConfigEntry.ALLOW_EXPLOSIONS.getBoolean())
        {
            msgNew("<red>Explosions are currently disabled.");
            return true;
        }

        double radius = 2.0;

        if (args.length >= 1)
        {
            if ("list".equals(args[0]))
            {
                final Iterator<Landmine> landmines = plugin.lm.getLandmines().iterator();
                while (landmines.hasNext())
                {
                    msgNew(landmines.next().toString());
                }
                return true;
            }

            try
            {
                radius = Math.max(2.0, Math.min(6.0, Double.parseDouble(args[0])));
            }
            catch (NumberFormatException ignored)
            {
            }
        }

        final Block landmine = playerSender.getLocation().getBlock().getRelative(BlockFace.DOWN);
        landmine.setType(Material.TNT);
        plugin.lm.add(new Landmine(landmine.getLocation(), playerSender, radius));

        msgNew("<green>Landmine planted - Radius: <radius> blocks.", Placeholder.unparsed("radius", String.valueOf(radius)));
        return true;
    }
}