package me.totalfreedom.totalfreedommod.command;

import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(permission = "report", source = SourceType.ONLY_IN_GAME, blockHostConsole = true)
@CommandParameters(description = "Report a player for all admins to see.", usage = "/<command> <player> <reason>")
public class Command_report extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length < 2)
        {
            return false;
        }

        OfflinePlayer player = Bukkit.getOfflinePlayer(args[0]);

        if (sender instanceof Player && (player.equals(playerSender)))
        {
            msgNew("<red>Please, don't try to report yourself.");
            return true;
        }

        if (plugin.al.isAdmin(player))
        {
            msgNew("<red>You can't report admins with this command.");
            return true;
        }

        String report = StringUtils.join(ArrayUtils.subarray(args, 1, args.length), " ");
        plugin.cm.reportAction(playerSender, player.getName(), report);

        boolean logged = false;

        if (plugin.dc != null && plugin.dc.isEnabled())
        {
            Player online = Bukkit.getPlayer(player.getUniqueId());
            logged = (online != null)
                    ? plugin.dc.sendReport(playerSender, online, report)
                    : plugin.dc.sendReportOffline(playerSender, player, report);
        }

        msgNew("<green>Thank you, your report has been successfully logged.");
        if (logged)
        {
            msgNew("<red>Note: This report has been logged to a Discord channel, as with any report system, spamming reports can lead to you getting banned.");
        }

        return true;
    }
}