package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandDependencies({"WorldEdit"})
@CommandPermissions(permission = "worldedit.limit.other", source = SourceType.BOTH)
@CommandParameters(description = "Sets a specific player's WorldEdit block modification limit to the default limit or to a custom limit.", usage = "/<command> <player> [limit]", aliases = "setpl,spl")
public class Command_setplayerlimit extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (!server.getPluginManager().isPluginEnabled("WorldEdit"))
        {
            msgNew("<red>WorldEdit is not enabled on this server.");
            return true;
        }

        int amount;
        if (args.length > 0)
        {
            Player player = Bukkit.getPlayer(args[0]);
            if (player == null)
            {
                msg(PLAYER_NOT_FOUND);
                return true;
            }

            if (args.length == 2)
            {
                try
                {
                    amount = Math.max(-1, Math.min(plugin.web.getMaxLimit(), Integer.parseInt(args[1])));
                } catch (NumberFormatException ex)
                {
                    msgNew("<red>Invalid number: <amount>", Placeholder.unparsed("amount", args[1]));
                    return true;
                }
            } else
            {
                amount = plugin.web.getDefaultLimit();
            }
        } else
        {
            return false;
        }

        Player player = Bukkit.getPlayer(args[0]);
        FUtil.adminAction(sender.getName(), "Setting " + player.getName() + "'s WorldEdit block modification limit to " + amount + ".", true);
        plugin.web.setLimit(player, amount);

        return true;
    }
}