package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import me.totalfreedom.totalfreedommod.config.ConfigEntry;
import me.totalfreedom.totalfreedommod.util.FLog;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

/*
 * See https://github.com/TotalFreedom/License - This file may not be edited or removed.
 */
@CommandPermissions(source = SourceType.BOTH)
@CommandParameters(description = "Shows information about TotalFreedomMod or reloads it", usage = "/<command> [reload]", aliases = "tfm")
public class Command_totalfreedommod extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length == 1)
        {
            if (!args[0].equals("reload"))
            {
                return false;
            }

            if (!plugin.al.isAdmin(sender))
            {
                noPerms();
                return true;
            }

            plugin.config.load();

            plugin.fsh.stopServices();
            plugin.fsh.startServices();

            msgNew("<name> v<version> reloaded.",
                    Placeholder.unparsed("name", TotalFreedomMod.pluginName),
                    Placeholder.unparsed("version", TotalFreedomMod.pluginVersion));
            FLog.info(String.format("%s v%s reloaded.",
                    TotalFreedomMod.pluginName,
                    TotalFreedomMod.pluginVersion));
            return true;
        }

        TotalFreedomMod.BuildProperties build = TotalFreedomMod.build;
        msgNew("<gold>TotalFreedomMod for 'Total Freedom', the original all-op server.");
        msgNew("<gold>Running on <server>.", Placeholder.unparsed("server", ConfigEntry.SERVER_NAME.getString()));
        msgNew("<gold>Created by Madgeek1450 and Prozza.");
        msgNew("<gold>Version <blue><codename> - <version> Build <number> </blue>(<blue><head></blue>)",
                Placeholder.unparsed("codename", build.codename),
                Placeholder.unparsed("version", build.version),
                Placeholder.unparsed("number", build.number),
                Placeholder.unparsed("head", build.head));
        msgNew("<gold>Compiled <blue><date></blue> by <blue><author></blue>",
                Placeholder.unparsed("date", build.date),
                Placeholder.unparsed("author", build.author));
        msgNew("<green>Visit <aqua>http://github.com/TotalFreedom/TotalFreedomMod</aqua> for more information.");

        return true;
    }
}