package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.player.FPlayer;
import me.totalfreedom.totalfreedommod.util.FUtil;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(permission = "unblockcmd", source = SourceType.BOTH)
@CommandParameters(description = "Unblocks commands for a player.", usage = "/<command> <player>", aliases = "unblockcommand,unblockcommands,ubcmds,unblockcmds,ubc")
public class Command_unblockcmd extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length == 0)
        {
            return false;
        }

        Player player = getPlayer(args[0]);
        if (player == null)
        {
            msg(PLAYER_NOT_FOUND);
            return true;
        }

        FPlayer fPlayer = plugin.pl.getPlayer(player);
        if (fPlayer.allCommandsBlocked())
        {
            fPlayer.setCommandsBlocked(false);
            FUtil.adminAction(sender.getName(), "Unblocking all commands for " + player.getName(), true);
            msgNew("Unblocked commands for <player>.");
        }
        else
        {
            msgNew("<red>That player's commands aren't blocked.");
        }
        return true;
    }
}