package me.totalfreedom.totalfreedommod.rank;

import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.luckperms.api.model.user.User;
import org.bukkit.ChatColor;
import org.bukkit.entity.Player;

import java.util.Set;

@FunctionalInterface
public interface GroupProvider<T extends DisplayableGroup>
{
    Component OPEN = Component.text("[", NamedTextColor.DARK_GRAY);
    Component CLOSE = Component.text("]", NamedTextColor.DARK_GRAY);

    GroupProvider<DisplayableGroup> NON_OP = () -> new DisplayableGroup("non_op", Component.text("Non-Ops"), Component.empty(), 0, NamedTextColor.WHITE, null, false, false);
    GroupProvider<DisplayableGroup> OP = () -> new DisplayableGroup("op", Component.text("Operators"), Component.text("Op"), 1, NamedTextColor.GREEN, null, false, false);
    GroupProvider<DisplayableGroup> MASTER_BUILDER = () -> new DisplayableGroup("builder", Component.text("Master Builders"), Component.text("MB"), 2, NamedTextColor.DARK_AQUA, ChatColor.DARK_AQUA, true, true);
    GroupProvider<DisplayableGroup> ADMIN = () -> new DisplayableGroup("admin", Component.text("Administrators"), Component.text("Admin"), 3, NamedTextColor.DARK_GREEN, ChatColor.DARK_GREEN, true, true);
    GroupProvider<DisplayableGroup> SENIOR_ADMIN = () -> new DisplayableGroup("senior", Component.text("Senior Administrators"), Component.text("SrA"), 4, NamedTextColor.GOLD, ChatColor.GOLD, true, true);

    static User getUser(Player player)
    {
        return TotalFreedomMod.getPlugin()
                .lpb.getAPI()
                .getPlayerAdapter(Player.class)
                .getUser(player);
    }

    static GroupProvider<DisplayableGroup> fromArgument(String arg)
    {
        return switch (arg.toLowerCase())
                {
                    case "op" -> OP;
                    case "builder" -> MASTER_BUILDER;
                    case "admin" -> ADMIN;
                    case "senior" -> SENIOR_ADMIN;
                    default -> NON_OP;
                };
    }

    static Set<GroupProvider<DisplayableGroup>> providerSet()
    {
        return Set.of(NON_OP, OP, MASTER_BUILDER, ADMIN, SENIOR_ADMIN);
    }

    T getGroup();
}