package me.totalfreedom.totalfreedommod.util;

import com.destroystokyo.paper.ParticleBuilder;
import org.bukkit.Color;
import org.bukkit.Location;
import org.bukkit.Particle;
import org.bukkit.entity.Player;
import org.bukkit.util.Vector;
import org.jetbrains.annotations.NotNull;

import java.util.Iterator;

public class ParticleDisplay
{
    private final Interpolation interpolation;
    private Iterator<Color> colorIterator;

    public ParticleDisplay()
    {
        this.interpolation = new Interpolation();
        this.colorIterator = interpolation.rainbow(43).iterator();
    }

    public void spawnNext(Player player)
    {
        Location location = getBehind(player);
        Color color = getIterator().next();
        Particle.DustOptions options = new Particle.DustOptions(color, 3);
        ParticleBuilder builder = new ParticleBuilder(Particle.REDSTONE);
        builder.data(options)
                .receivers(30, 15, true)
                .offset(0.5, 0.5, 0.5)
                .location(location)
                .spawn();
    }

    private Location getBehind(Player player)
    {
        @NotNull Vector inverse = player.getLocation()
                .clone()
                .getDirection()
                .normalize()
                .multiply(-1);

        return player.getLocation().add(inverse);
    }

    private Iterator<Color> getIterator()
    {
        if (!this.colorIterator.hasNext())
        {
            this.colorIterator = interpolation.rainbow(43).iterator();
        }

        return this.colorIterator;
    }
}
